# -*- coding: utf-8 -*-
#
# e-PRTR XML-2 Import
# (c) 2009, 2010 Matthias Lüttgert, ENDA GmbH & Co. KG
# (c) 2009 Matthias Lüttgert, Torsten Lüdtke, RISA GmbH
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 3 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, see <http://www.gnu.org/licenses/>.
#
# DEUTSCH:
#
# Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU
# General Public License, wie von der Free Software Foundation veröffentlicht,
# weitergeben und/oder modifizieren, entweder gemäß Version 3 der Lizenz oder
# (nach Ihrer Option) jeder späteren Version.
#
# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
# Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
# Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN
# ZWECK. Details finden Sie in der GNU General Public License.
#
# Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
# Programm erhalten haben. Falls nicht, siehe <http://www.gnu.org/licenses/>.
class P_VAbwasser_GeheimK

  def initialize(p_vabw_id, kennnr, geheimk_id, owner_id, datumvon, datumbis)
    @errors = 0
    @p_vabw_id  = p_vabw_id
    @kennnr     = kennnr
    @geheimk_id = geheimk_id
    @owner_id   = owner_id
    @datumvon   = datumvon
    @datumbis   = datumbis
  end

  def errors
    return @errors
  end

  def save
    lastid = VAbwasserGK.order("id desc").first
    unless lastid == nil
      @id = lastid.id + 1
    else
      @id = 1
    end

    lastido = VAbwasserGK.order("ido desc").first
    unless lastido == nil
      @ido = lastido.ido + 1
    else
      @ido = 1
    end

    VAbwasserGK.new do |vagk|
      vagk.id            = @id
      vagk.ido           = @ido
      vagk.state         = 0
      vagk.date_from     = @datumvon
      vagk.time_from     = 0
      vagk.date_to       = @datumbis
      vagk.time_to       = 0
      vagk.date_create   = now_date
      vagk.time_create   = now_time
      vagk.owner_id      = @owner_id
      vagk.creator_id    = @owner_id
      vagk.operation_id  = 4
      vagk.process       = @owner_id
      vagk.p_vabw_id     = @p_vabw_id
      vagk.geheimk_id    = @geheimk_id

      begin
        vagk.save!
      rescue Exception => rumms
        puts "Fehler beim Speichern in p_vabw_geheimk. rumms: <#{rumms}>"
      end
    end
  end
end
